SystemOrganization addCategory: #OrionBrowser!
SystemOrganization addCategory: #'OrionBrowser-Test'!

!ASMethod methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/20/2013 09:17'!
addInvocationTo: aMethod inModel: aModelVersion

	(ASActionAddInvocation new
		antaresModel: aModelVersion;
		from: self ;
		to: aMethod)
	manualRun. ! !

!ASMethod methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/20/2013 09:17'!
addReferenceTo: aClass inModel: aModelVersion

	(ASActionAddReference new
		antaresModel: aModelVersion;
		from: self ;
		to: aClass )
	manualRun. ! !

!ASMethod methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:08'!
deleteInModel: aModelVersion

	(ASActionRemoveMethod new
		antaresModel: aModelVersion ;
		entity: self )
	manualRun. ! !

!ASMethod methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/19/2013 19:37'!
moveTo: aClass inModel: aModelVersion

	(ASActionMoveMethod new
		antaresModel: aModelVersion ;
		entity: self ;
		newContainer: aClass )
	manualRun. ! !

!ASInvocation methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:13'!
deleteInModel:  aModelVersion
	(ASActionRemoveInvocation new
		antaresModel: aModelVersion;
		entity: self )
	manualRun. 
! !

!ASPackage methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/19/2013 18:48'!
addClassNamed: aString inModel: aModelVersion

	aString  ifNotNil: [ 
		(ASActionAddClass new
			antaresModel: aModelVersion ;
			container: self ;
			newName: aString )
		manualRun ]! !

!ASPackage methodsFor: '*OrionBrowser' stamp: 'AnneEtien 3/19/2013 14:11'!
deleteInModel: aModelVersion

	(ASActionRemovePackage new
		antaresModel: aModelVersion ;
		entity: self )
	manualRun. ! !

!ASPackage methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 10:56'!
mergePackage: aPackage inModel: aModelVersion

	(ASActionMergePackage  new
		antaresModel: aModelVersion ;
		entity: self ;
		newContainer: aPackage )
	manualRun. 
! !

!ASInheritance methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:13'!
deleteInModel:  aModelVersion
	(ASActionRemoveInheritance new
		antaresModel: aModelVersion;
		entity: self )
	manualRun. 
! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/19/2013 18:46'!
addAttributNamed: aString inModel: aModelVersion

	aString  ifNotNil: [ 
		(ASActionAddAttribute new
			antaresModel: aModelVersion ;
			container: self ;
			newName: aString )
		manualRun ]! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/19/2013 18:48'!
addMethodNamed: aString inModel: aModelVersion

	aString  ifNotNil: [ 
		(ASActionAddMethod new
			antaresModel: aModelVersion ;
			container: self ;
			newName: aString )
		manualRun ]! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/20/2013 09:16'!
addSuperClass: newSuperClass inModel: aModelVersion 

	(ASActionAddInheritance new
		antaresModel: aModelVersion ;
		from: self ;
		to:  newSuperClass )
	manualRun. ! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'janniklaval 3/27/2013 11:33'!
changeSuperClassTo: newSuperClass inModel: aModelVersion 

	(ASActionReplaceInheritance new 
			antaresModel: aModelVersion; 
			entity: self;
			from: self ;
			to: newSuperClass) 
			manualRun! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:07'!
deleteInModel: aModelVersion

	(ASActionRemoveClass new
		antaresModel: aModelVersion ;
		entity: self )
	manualRun. 
! !

!ASClass methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/19/2013 19:34'!
moveTo: aPackage inModel: aModelVersion

	(ASActionMoveClass new
		antaresModel: aModelVersion ;
		entity: self ;
		newContainer: aPackage )
	manualRun. 
! !

!ASReference methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:14'!
deleteInModel:  aModelVersion
	(ASActionRemoveReference new
		antaresModel: aModelVersion;
		entity: self )
	manualRun. ! !

ASTest subclass: #OrionBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser-Test'!

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:16'!
testAddAttribute

	| asS antaresModel  |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	self assert: (antaresModel entityNamed: 'Smalltalk::Class1.attributeTest') isNil.

	(antaresModel entityNamed: 'Smalltalk::Class1') addAttributNamed: 'attributeTest' inModel: antaresModel .

	self deny: (antaresModel entityNamed: 'Smalltalk::Class1.attributeTest') isNil.
	self assert: (antaresModel entityNamed: 'Smalltalk::Class1.attributeTest') parentType equals: (antaresModel entityNamed: 'Smalltalk::Class1').! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:17'!
testAddAttributeNoName

	| asS antaresModel |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	self assert: (antaresModel entityNamed: 'Smalltalk::Class1.attributeTest') isNil.

	(antaresModel entityNamed: 'Smalltalk::Class1') addAttributNamed: nil inModel: antaresModel .

	self assert: (antaresModel entityNamed: 'Smalltalk::Class1.attributeTest') isNil.! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:18'!
testAddClass

	| asS antaresModel |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	self assert: (antaresModel entityNamed: 'Orion-TestModel-Constellation1::ClassTest') isNil.

	(antaresModel entityNamed: 'Orion-TestModel-Constellation1') addClassNamed: 'ClassTest' inModel: antaresModel .

	self deny: (antaresModel entityNamed: 'Orion-TestModel-Constellation1::ClassTest') isNil.
	self assert: (antaresModel entityNamed: 'Orion-TestModel-Constellation1::ClassTest') parentPackage equals: (antaresModel entityNamed: 'Orion-TestModel-Constellation1').! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:19'!
testAddClassNoName

	| asS antaresModel |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	self assert: (antaresModel entityNamed: 'ClassTest') isNil.

	(antaresModel entityNamed: 'Orion-TestModel-Constellation1') addClassNamed: nil inModel: antaresModel .

	self assert: (antaresModel entityNamed: 'Orion-TestModel-Constellation1::ClassTest') isNil.! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:19'!
testAddMethod

	| asS antaresModel |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	self assert: (antaresModel entityNamed: 'Smalltalk::Class1.methodTest()') isNil.

	(antaresModel entityNamed: 'Smalltalk::Class1') addMethodNamed: 'methodTest' inModel: antaresModel .

	self deny: (antaresModel entityNamed: 'Smalltalk::Class1.methodTest()') isNil.
	self assert: (antaresModel entityNamed: 'Smalltalk::Class1.methodTest()') parentType equals: (antaresModel entityNamed: 'Smalltalk::Class1')! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:20'!
testAddMethodNoName

	| asS antaresModel |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	self assert: (antaresModel entityNamed: 'Smalltalk::Class1.methodTest()') isNil.

	(antaresModel entityNamed: 'Smalltalk::Class1') addMethodNamed: nil inModel: antaresModel .

	self assert: (antaresModel entityNamed: 'Smalltalk::Class1.methodTest()') isNil.! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:21'!
testAddPackage

	| asS antaresModel |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	self assert: (antaresModel entityNamed: 'PackageTest') isNil.

	antaresModel addPackageNamed: 'PackageTest'.

	self deny: (antaresModel entityNamed: 'PackageTest') isNil.! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:21'!
testAddPackageNoName

	| asS antaresModel |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	self assert: (antaresModel entityNamed: 'PackageTest') isNil.

	antaresModel addPackageNamed: nil.

	self assert: (antaresModel entityNamed: 'PackageTest') isNil.! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:22'!
testClassAddInheritance

	| asS antaresModel class |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	class := antaresModel entityNamed: 'Smalltalk::Class1'.	

	self assert: class superInheritances size equals: 1.
	self assert: class superInheritances first to equals: (antaresModel entityNamed: 'Smalltalk::Object').

	class addSuperClass: (antaresModel entityNamed: 'Smalltalk::Class5') inModel:  antaresModel .
	
	class := antaresModel entityNamed: 'Smalltalk::Class1'.	

	self assert: class superInheritances size equals: 2.
	self assert: (class superInheritances contains: [:inh | inh to = (antaresModel entityNamed: 'Smalltalk::Object')]).
	self assert: (class superInheritances contains: [:inh | inh to = (antaresModel entityNamed: 'Smalltalk::Class5')]).
! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'janniklaval 3/27/2013 11:26'!
testClassChangeInheritance

	| asS antaresModel class |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	class := antaresModel entityNamed: 'Smalltalk::Class1'.	

	self assert: class superInheritances size equals: 1.
	self assert: class superInheritances first to equals: (antaresModel entityNamed: 'Smalltalk::Object').

	class changeSuperClassTo: (antaresModel entityNamed: 'Smalltalk::Class5') inModel:  antaresModel .

	class := antaresModel entityNamed: 'Smalltalk::Class1'.	
	self assert: (class superInheritances size) equals: 1.
	self assert: (class superInheritances first to) equals: (antaresModel entityNamed: 'Smalltalk::Class5').
! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:24'!
testDeleteAttribute

	| asS antaresModel att |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	att := antaresModel entityNamed: 'Smalltalk::Object.DependentsFields'.	

	self assert: att notNil.

	att deleteInModel: antaresModel .

	self assert: (antaresModel entityNamed: 'Smalltalk::Object.DependentsFields') isNil.! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:24'!
testDeleteClass

	| asS antaresModel class |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	class := antaresModel entityNamed: 'Smalltalk::Class1'.	

	self assert: class notNil.
	class deleteInModel: antaresModel .

	self assert: (antaresModel entityNamed: 'Smalltalk::Class1') isNil.! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:25'!
testDeleteInvocation

	| asS antaresModel meth |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	meth := 	antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.
	self assert: meth outgoingInvocations size equals: 1.

	meth outgoingInvocations first deleteInModel: antaresModel.
	
	meth := 	antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.
	self assert: meth outgoingInvocations size equals: 0.
! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:25'!
testDeleteMethod

	| asS antaresModel meth |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	meth := antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.	

	self assert: meth notNil.

	meth deleteInModel: antaresModel .

	self assert: (antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()') isNil.! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'AnneEtien 3/18/2013 18:08'!
testDeletePackage

	| asS antaresModel pckg |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: #AsM.
	
	pckg := antaresModel entityNamed: 'Orion-TestModel-Constellation1'.	

	self assert: pckg notNil.

	pckg deleteInModel: antaresModel .

	self assert: (antaresModel entityNamed: 'Orion-TestModel-Constellation1') isNil.! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:26'!
testDeleteReference

	| asS antaresModel meth |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	meth := 	antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.
	self assert: meth outgoingReferences size equals: 1.

	(meth outgoingReferences first) deleteInModel: antaresModel.
	
	meth := 	antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.
	self assert: meth outgoingReferences size equals: 0.
! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:27'!
testMergePackage

	| asS antaresModel pckg1 pckg2 |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	pckg1 := antaresModel entityNamed: 'Orion-TestModel-Constellation1'.	
	pckg2 := antaresModel entityNamed: 'Orion-TestModel-Constellation2'.

	self assert: pckg1 childNamedEntities size equals: 5.
	self assert: pckg2 childNamedEntities size equals: 4.

	pckg1 mergePackage: pckg2  inModel: antaresModel.

	self assert:  (antaresModel entityNamed: 'Orion-TestModel-Constellation1')  equals: nil.
	"self assert:  (antaresModel entityNamed: 'Orion-TestModel-Constellation2')  equals: nil.     DOESN'T WORK BECAUSE MATCHES Orion-TestModel-Constellation2Orion-TestModel-Constellation1"

	self deny:  (antaresModel entityNamed: 'Orion-TestModel-Constellation2Orion-TestModel-Constellation1') isNil.
	self assert: (antaresModel entityNamed: 'Orion-TestModel-Constellation2Orion-TestModel-Constellation1') childNamedEntities size equals: 9.
! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:27'!
testMethodAddInvocation

	| asS antaresModel meth |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	meth := 	antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.

	self assert: meth outgoingInvocations size equals: 1.
	self assert: meth outgoingInvocations first receiver equals: (antaresModel entityNamed: 'Smalltalk::Class3').

	meth addInvocationTo: (antaresModel entityNamed: 'Smalltalk::Class1.accessOrion1Class2()') inModel:  antaresModel .
	
	meth := 	antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.

	self assert: meth outgoingInvocations size equals: 2.
	self assert: (meth outgoingInvocations contains: [:inv | inv receiver = (antaresModel entityNamed: 'Smalltalk::Class3')]).
	self assert: (meth outgoingInvocations contains: [:inv | inv to size =1 and: [ inv to  first = (antaresModel entityNamed: 'Smalltalk::Class1.accessOrion1Class2()')]]).
! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:27'!
testMethodAddReference

	| asS antaresModel meth |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	meth := 	antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.

	self assert: meth outgoingReferences size equals: 1.
	self assert: meth outgoingReferences first to equals: (antaresModel entityNamed: 'Smalltalk::Class3').

	meth addReferenceTo: (antaresModel entityNamed: 'Smalltalk::Class2') inModel:  antaresModel .
	
	meth := 	antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.

	self assert: meth outgoingReferences size equals: 2.
	self assert: (meth outgoingReferences contains: [:inh | inh to = (antaresModel entityNamed: 'Smalltalk::Class3')]).
	self assert: (meth outgoingReferences contains: [:inh | inh to = (antaresModel entityNamed: 'Smalltalk::Class2')]).
! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:32'!
testMoveAttribute

	| asS antaresModel att  |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	att := antaresModel entityNamed: 'Smalltalk::Object.DependentsFields'.	

	self deny: att isNil.
	self assert: att parentType equals: (antaresModel entityNamed: 'Smalltalk::Object').	

	att moveTo: (antaresModel entityNamed: 'Smalltalk::Class1') inModel: antaresModel.

	att := antaresModel entityNamed: 'Smalltalk::Object.DependentsFields'.	
	self assert: att isNil.
	
	att := antaresModel entityNamed: 'Smalltalk::Class1.DependentsFields'.	
	
	self deny: att isNil.
	self assert: att parentType equals: (antaresModel entityNamed: 'Smalltalk::Class1').! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:36'!
testMoveClass

	| asS antaresModel class |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	class := antaresModel entityNamed: 'Smalltalk::Class1'.	
	self deny: class isNil.
	self assert: class parentPackage equals: (antaresModel entityNamed: 'Orion-TestModel-Constellation1').	

	class moveTo: (antaresModel entityNamed: 'Orion-TestModel-Constellation2') inModel: antaresModel .

	class := antaresModel entityNamed: 'Smalltalk::Class1'.	
	self deny: class isNil.
	self assert: class parentPackage equals: (antaresModel entityNamed: 'Orion-TestModel-Constellation2').! !

!OrionBrowserTest methodsFor: 'as yet unclassified' stamp: 'NicolasAnquetil 3/19/2013 19:38'!
testMoveMethod

	| asS antaresModel meth |

	asS := self model system.
	antaresModel := (ASModel withParent: self model) name: 'AsM'.

	meth := antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.	
	self deny: meth isNil.
	self assert: meth parentType equals: (antaresModel entityNamed: 'Smalltalk::Class5').	

	meth moveTo: (antaresModel entityNamed: 'Smalltalk::Class1') inModel: antaresModel.

	meth := antaresModel entityNamed: 'Smalltalk::Class5.accessOrion2Class3()'.	
	self assert: meth isNil.
	
	meth := antaresModel entityNamed: 'Smalltalk::Class1.accessOrion2Class3()'.	
	self deny: meth isNil.
	self assert: meth parentType equals: (antaresModel entityNamed: 'Smalltalk::Class1').! !

!ASAttribute methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/16/2013 11:05'!
deleteInModel: aModelVersion

	(ASActionRemoveAttribute new
		antaresModel: aModelVersion ;
		entity: self )
	manualRun. 
! !

!ASAttribute methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/19/2013 19:30'!
moveTo: aClass inModel: aModelVersion

	(ASActionMoveAttribute  new
		antaresModel: aModelVersion ;
		entity: self ;
		newContainer: aClass )
	manualRun. 
! !

!ASModel methodsFor: '*OrionBrowser' stamp: 'NicolasAnquetil 3/19/2013 18:48'!
addPackageNamed: aString

	aString notNil ifTrue: [ 
		(ASActionAddPackage new
			antaresModel: self;
			newName: aString )
		manualRun ]! !

ASAnnouncement subclass: #ASEntityBuffered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

Object subclass: #ASBrowser
	instanceVariableNames: 'selectedVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

!ASBrowser class methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:36'!
open 

	self new browser openOn: ASSystem root first! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
actionsFor: each
	|posAction elements listOfAct |

	elements :=  each selection mooseInterestingEntity.
	posAction := (((ASAction withAllSubclasses flatCollect: [:act | Pragma allNamed: #AntaresActionFor: in: act class])
					select:[:e | e arguments includes: elements class asString asSymbol]) collect:[:e | e methodClass soleInstance]) asOrderedCollection.
	listOfAct := OrderedCollection new.
	posAction do:[:ie | 
						|depend|
						depend := ie needs: elements.
						depend isNil 
							ifTrue:[
								listOfAct add:(
								(GLMAction new)
									action:[:anAct | 
										elements currentContext isModifiable ifTrue:[
											ie new entity: elements; antaresModel: elements currentContext; manualRun.
											elements currentContext system announcer announce: ASModelChanged]
										ifFalse:[
											ie new entity:elements; runOnNewVersionFrom: elements currentContext.
											elements currentContext system announcer announce: ASModelAdded
										]
									];
									title:ie description;
									yourself).]
							ifFalse:[
								depend do:[:anEl |
									listOfAct add:(
									(GLMAction new)
										action:[:anAct | 
											elements currentContext isModifiable ifTrue:[
												ie new entity:elements; to:anEl; antaresModel: elements currentContext; manualRun.
												elements currentContext system announcer announce: ASModelChanged]
											ifFalse:[
												ie new entity:elements; to:anEl; runOnNewVersionFrom: elements currentContext.
												elements currentContext system announcer announce: ASModelAdded]
										];
										title:anEl mooseName;
										category:ie description;
										yourself).]].				
				].
	^listOfAct.! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
browser
	"
		self new browser openOn: ASSystem root
	"
	| browser  |
	
	browser := GLMTabulator new.
	
	browser column: #models span: 1; column: [:c | c row:#versions; row: #changes] span: 1; column: #categories span: 4.
	(browser transmit) to: #models; andShow: [:b |
		b list
			format:[:system | system name];
			display: [:each | each ].
	].
	
	(browser transmit) from: #models; to: #versions; andShow: [:b | 
		b tree
			allExpanded;
			format:[:system | system name];
			display: [:each | each antaresModels select:[:om | om parentModel = nil]];
			children: [:each | each childrenModel];
			act: [:each | each selection inspect] entitled: 'inspect';
			act: [:each | |new|
				new := each selection createNewChildVersion. ASSystem announcer announce: ASModelAdded. browser announce: ASAnnouncement] entitled: 'create a child version';
			act: [:each | each selection delete. ASSystem announcer announce: ASModelRemoved. browser announce: ASAnnouncement] entitled: 'delete'.
	].
	(browser transmit) to: #changes; from: #versions; andShow: [:b |
		b list
			display: [:each | each changes];
			title: [ :each | each changes size asString, ' changes'].
	].
	(browser transmit) to: #categories; from: #versions; andShow: [:b |
		b finder
			show: [:a |
				a custom: (self groupList).
				a custom: self entityNavigation.
			].
	 ].
	browser subscribe: ASAnnouncement do: [browser update].
	^ browser! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 1/16/2013 10:13'!
displayFor: anObject
	| entity pragmaValueAssociations |
	entity := anObject mooseInterestingEntity.
	pragmaValueAssociations := entity complexPropertyPragmas collect: [ :pragma | 
		pragma -> (anObject mooseInterestingEntity perform: pragma selector) mooseInterestingEntity ].
	^ (pragmaValueAssociations
		reject: [ :association | 
			association value isNil or: [ 
				association value isCollection and: [ 
					association value isEmpty ] ] ])
		sorted: [:a :b | 
			(a key argumentAt: 1) asLowercase asString < (b key argumentAt: 1) asLowercase asString ]! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 1/16/2013 10:26'!
entityNavigation
	^ GLMListPresentation new
			title: 'Navigation';
			display: [ :anObject | |entity |
				entity := anObject mooseInterestingEntity.
				(entity mooseInterestingEntity isKindOf: FAMIXEntity) ifFalse:[self selectedVersion: entity] ifTrue:[entity currentContext: self selectedVersion.].
				self displayFor: entity value.
			];
			when: [:input | input mooseInterestingEntity isCollection not or: [input mooseInterestingEntity isKindOf: MooseModel] ];
			dynamicActionsOnSelection: [ :list | list selection mooseInterestingEntity mooseFinderActions ].! !

!ASBrowser methodsFor: 'as yet unclassified' stamp: 'janniklaval 12/24/2012 18:08'!
groupList
	^ GLMListPresentation new
			beMultiple;
			showOnly: 50;
			display: [:e | e mooseInterestingEntity];
			send: [:each | each isNil ifTrue: [nil] ifFalse: [each asMooseGroup]];
			format: #mooseName;
			title: [ :each | each mooseInterestingEntity size asString, ' items'];
			when: [:input | (input mooseInterestingEntity isKindOf: MooseGroup) or:[
					(input mooseInterestingEntity isKindOf: Collection) and:[(input mooseInterestingEntity isKindOf: ByteSymbol)not]]];
			dynamicActionsOnSelection: [ :list | OrderedCollection new 
					addAll: list selection mooseInterestingEntity mooseFinderActions;
					addAll: (self actionsFor: list);
					yourself].
				
	! !

!ASBrowser methodsFor: 'accessing' stamp: 'janniklaval 12/23/2012 08:25'!
selectedVersion
	^ selectedVersion! !

!ASBrowser methodsFor: 'accessing' stamp: 'janniklaval 12/23/2012 08:25'!
selectedVersion: anObject
	selectedVersion := anObject! !

Object subclass: #OrionBrowser
	instanceVariableNames: 'selectedVersion actionDict browser entityInSummary entityInBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrionBrowser'!

!OrionBrowser class methodsFor: 'as yet unclassified' stamp: 'na 1/19/2013 12:46'!
open 

	self new browser openOn: ASSystem root! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 2/21/2013 16:55'!
browser

	browser := GLMTabulator new.
	
	browser
		title: 'Orion Browser' ;
		column: [:c | c
				row:  #models ;
				row: #buffer size: 60 ]  span: 2 ;
		column: #packages  span: 2 ;
		column: #classes  span: 2 ;
		column: [:c | c
				row:  #attributes ;
				row:  #methods ]   span: 2 ;
		column: #links  span: 2 ;
		column: #summary span: 3.

	self
		browserModels ;
		browserBuffer ;
		browserPackages ;
		browserClasses ;
		browserAttributes ;
		browserMethods ;
		browserLinks ;
		browserSummary.
	
	browser subscribe: ASAnnouncement do: [ browser update].
	^ browser! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/19/2013 19:29'!
browserAttributes
	(browser transmit) to: #attributes; from: #classes; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | (anEntity attributes )  sorted: [:c1 :c2 | c1 name < c2 name] ];
			title: [ :each | ' Attributes'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;
		
			selectionAct: [:list | list selection deleteInModel: selectedVersion] entitled: 'Remove' ;
			selectionAct: [:list | list selection moveTo: entityInBuffer inModel: selectedVersion] entitled: 'Move to buffered class'.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 09:53'!
browserBuffer

	(browser transmit) to: #buffer; from: #packages port: #strongSelection; when: #notNil; andShow: [:a |
		a list
			display: [:anEntity | entityInBuffer := anEntity. {anEntity} ];
			title: 'Buffered'
	].

	(browser transmit) to: #buffer; from: #classes port: #strongSelection; when: #notNil; andShow: [:a |
		a list
			display: [:anEntity | entityInBuffer := anEntity. {anEntity} ];
			title: 'Buffered'
	].

	(browser transmit) to: #buffer; from: #methods port: #strongSelection; when: #notNil; andShow: [:a |
		a list
			display: [:anEntity | entityInBuffer := anEntity. {anEntity} ];
			title: 'Buffered'
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/19/2013 19:34'!
browserClasses

	(browser transmit) to: #classes; from: #packages; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | (anEntity classes)  sorted: [:c1 :c2 | c1 name < c2 name]];
			title: [ :each | ' Classes'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;
	
			selectionAct:  [:list | list selection addSuperClass: entityInBuffer inModel: selectedVersion]  entitled: 'Add inheritance from the buffered class' ;
			selectionAct:  [:list | list selection changeSuperClassTo: entityInBuffer inModel: selectedVersion]  entitled: 'Change super class for the buffered class' ;
			selectionAct:  [:list | list selection addAttributNamed: (self getNameDialog:  'New attribute name') inModel: selectedVersion]  entitled: 'Add attribute' ;
			selectionAct:  [:list | list selection addMethodNamed: (self getNameDialog:  'New method name') inModel: selectedVersion]  entitled: 'Add method' ;
			selectionAct: [:list | list selection deleteInModel: selectedVersion] entitled: 'Remove' ;	
			selectionAct: [:list | list selection moveTo: entityInBuffer inModel: selectedVersion] entitled: 'Move to buffered package' .
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 11:11'!
browserLinks

	"{#classes . #methods . #attributes} do: [:srcPanel |"

	(browser transmit) to: #links ; from: #classes ; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			title: 'Links' ;
			display: [ :anObject | (((anObject incomingReferences) union: (anObject superInheritances  )) union: (anObject subInheritances) ) sorted: [:x :y | x mooseName < y mooseName]] ;
			 
			format: [:aProp | (aProp asString)];
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;

			selectionAct:  [:list | list selection deleteInModel: selectedVersion]  entitled: 'Remove the Link'.
		].
	

	
	(browser transmit) to: #links ; from: #methods ; andShow:[:b | | gmlList |
		gmlList := b list.
		gmlList
			title: 'Links' ;
			display: [ :anObject | (anObject outgoingReferences ) 
					union: ((anObject incomingInvocations) union: (anObject outgoingInvocations  )) ] ;
			sorted: [:x :y | x mooseName < y mooseName] ;
			format: [:aProp | (aProp asString)];
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;
			
			selectionAct:  [:list | self remove:( list selection)]  entitled: 'Remove the Link'.
		].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/19/2013 19:37'!
browserMethods
	(browser transmit) to: #methods; from: #classes; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:anEntity | (anEntity methods)  sorted: [:c1 :c2 | c1 name < c2 name] ];
			title: [ :each | 'Methods'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;

			 selectionAct: [:list | list selection deleteInModel: selectedVersion] entitled: 'Remove' ;
			selectionAct: [:list | list selection moveTo: entityInBuffer inModel: selectedVersion] entitled: 'Move to the buffered class' ;
			selectionAct: [:list | list selection addReferenceTo: entityInBuffer inModel: selectedVersion] entitled: 'Add reference to the buffered class' ;
			selectionAct: [:list | list selection addInvocationTo: entityInBuffer inModel: selectedVersion] entitled: 'Add invocation to the buffered method'.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'AnneEtien 3/20/2013 14:05'!
browserModels

	(browser transmit) to: #models; andShow: [:b | | gmlTree |
		gmlTree := b tree.
		gmlTree
			allExpanded;
			display: [:systems | systems flatCollect: [:aSystem | aSystem antaresModels select:[:versions | versions parentModel isNil]]];
			format:[:aVersion | aVersion name];
			children: [:aVersion | aVersion childrenModel] ;

			selectionAct: [:list | list selection inspect] entitled:  'Inspect';

			selectionAct: [:theList | 
						theList selection createNewChildVersion.
						browser announce: ASAnnouncement]
				entitled: 'Create a child version' ;

			selectionAct: [:theList | 
						theList selection delete.
						browser announce: ASAnnouncement]
				entitled: 'Delete version'  ;

			selectionAct: [:list | list selection addPackageNamed: (self getNameDialog:  'New package name')] entitled: 'Add a package'.	

		self	versionChangesPane: gmlTree.
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 11:17'!
browserPackages

	(browser transmit) to: #packages ; from:#models; andShow: [:b | | gmlList |
		gmlList := b list.
		gmlList
			display: [:model |
				self selectedVersion: model.
				(model allWithType: ASPackage) sorted: [:c1 :c2 | c1 name < c2 name] ] ;
			title: [ :each | ' Packages'] ;
			selectionAct: [:list | list selection inspect] entitled:  'Inspect' ;
			selectionAct: [:list |  list selection addClassNamed: (self getNameDialog:  'New class name') inModel: selectedVersion]  entitled: 'Add a class' ;
			selectionAct: [:list | list selection deleteInModel: selectedVersion] entitled: 'Remove' ;
			selectionAct: [:list | list selection mergePackage: entityInBuffer inModel: selectedVersion] entitled: 'Merge with buffered package' .		
	].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 1/29/2013 18:06'!
browserSummary

	{#models . #packages .  #classes . #methods} do: [:srcPanel |

	(browser transmit) to: #summary ; from: srcPanel ; andShow: [:b |
		b  list
			noSelection ;
			title: 'Properties' ;
			display: [ :anObject | entityInSummary := anObject. anObject mooseInterestingEntity mooseDescription allPrimitiveAttributes ] ;
			sorted: [:x :y | x name < y name] ;
			format: [:aProp | aProp name ,  '= ' ,  ([(entityInSummary mooseInterestingEntity mmGetProperty: aProp) asString] on: Error do: ['error']) ]  ;
			when: [ :anObject | 
				(anObject mooseInterestingEntity isKindOf: MooseEntity) and: [
					anObject mooseInterestingEntity mooseDescription allPrimitiveAttributes notEmpty ]]]
		].
! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/21/2013 19:35'!
displayFor: anObject
	| entity pragmaValueAssociations |
	entity := anObject mooseInterestingEntity.
	pragmaValueAssociations := entity complexPropertyPragmas collect: [ :pragma | 
		pragma -> (anObject mooseInterestingEntity perform: pragma selector) mooseInterestingEntity ].
	^ (pragmaValueAssociations
		reject: [ :association | 
			association value isNil or: [ 
				association value isCollection and: [ 
					association value isEmpty ] ] ])
		sorted: [:a :b | 
			(a key argumentAt: 1) asLowercase asString < (b key argumentAt: 1) asLowercase asString ]! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/21/2013 19:50'!
formatFor: each
	^ (' ' join: ((each key argumentAt: 1) piecesCutWhereCamelCase collect: #capitalized)) , ' - ' , (each value mooseDisplayString contractTo: 50)! !

!OrionBrowser methodsFor: 'gui' stamp: 'NicolasAnquetil 3/16/2013 11:17'!
getNameDialog: aString
	
	| wizardControl  wizardPane textFieldPart defaultText |

	defaultText :=  '--Enter name--'.
	
	wizardControl := WizardControl new.
	wizardControl renderer: MerlinMorphicWizardRenderer new.
	
	wizardPane := WizardSinglePane new.
	
	textFieldPart := TextFieldPart  new
									inGroupboxNamed: aString;
									defaultValue: defaultText ;
									yourself.
	
	wizardPane row: textFieldPart associatedTo: #textFieldValue.
		
	wizardControl 
		addPane: wizardPane.
		
	wizardControl open. 
	((wizardControl wizardInformations at: #textFieldValue) = defaultText)
		ifTrue: [^ nil]
		ifFalse: [^ wizardControl wizardInformations at: #textFieldValue]! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/15/2013 15:31'!
selectedVersion
	^ selectedVersion! !

!OrionBrowser methodsFor: 'accessing' stamp: 'na 1/15/2013 15:31'!
selectedVersion: anObject
	selectedVersion := anObject! !

!OrionBrowser methodsFor: 'gui' stamp: 'na 1/20/2013 11:41'!
versionChangesPane: gmlTree

		gmlTree
			selectionSpawn: [:theList |
				|tmpBrowser|
				tmpBrowser := GLMTabulator new row: #one; "initialExtent: 100@100 ;" yourself.
				tmpBrowser
					transmit to: #one ; andShow: [:brows |
						brows tree
							display: [:aVersion | aVersion changes select: [:chg | chg parentAction isNil]] ;
							children: [:aChange | aChange childrenActions];
							format:[:aChange | aChange printWorkspace];
							title: [ :aVersion | ' Changes in ' , (aVersion name)] ].
				tmpBrowser startOn: theList selection
				] entitled: 'List changes' .! !
